/* Reminder.m created by wjabi on Sat 17-Jan-1998 */

#import "Reminder.h"

@implementation Reminder

-(id) init
{
    [super init];
    reminderString = @"";
    repeats = NO;
    return self;
}

- (void) setStringValue:(NSString *)aString
{
    if(reminderString)
      {
        [reminderString autorelease];
      }
    reminderString = [aString copy];
}

- (NSString *) stringValue
{
    return reminderString;
}

- (void) setRepeats:(BOOL)value
{
    repeats = value;
}

- (BOOL) getRepeats
{
    return repeats;
}

- (id) setReminder:(long)seconds :aTarget :(SEL)aSelector :(BOOL)repeatValue :(NSString *)aString
{
    repeats = repeatValue;
    [self setStringValue:aString];
    if(timer)
      {
        [timer invalidate];
        [timer autorelease];
      }
    timer = [NSTimer scheduledTimerWithTimeInterval:(NSTimeInterval)seconds target:aTarget selector:aSelector userInfo:self repeats:(BOOL)repeats];
    [timer retain];
    return self;
}

- (void) cancelReminder
{
    if(timer)
      {
        [timer invalidate];
        [timer autorelease];
      }
}

- (BOOL) getValid
{
    if(timer)
      {
        return [timer isValid];
      }
    else
      {
        return NO;
      }
}

- (NSTimeInterval) remainingTime
{
    NSDate *fireDate;
    NSTimeInterval timeInterval = 0;
    if(timer)
      {
        if([timer isValid])
          {
            fireDate = [timer fireDate];
            timeInterval = [fireDate timeIntervalSinceNow];
          }
      }
    if(timeInterval > 0)
      {
        return timeInterval;
      }
    else
      {
        return 0;
      }
}
@end
